{ IPX Unit 2.0A for Ichat 30/11/00}
{ 18:13 18.3.2001 komentare }

{ NEW:
  zmeneny typ posielaneho paketu z 0 na 4;
  zmenene volanie drivera z int 7a na
  priamy skok na adresu. Pozity sposob z
  IPX unity od Grega Millera, pridany
  register Cx;
  }

unit ipxsmall;
{$F+}
interface

uses dos;

type
  netAddr  = array[1..4] of byte;    { adresa siete }
  nodeAddr = array[1..6] of byte;    { adresa uzla v sieti }

  address  = array[0..1] of word;    { adresa, DWORD 0=offset 1=seg }

  netAddress = record
                 Net    : netAddr;   { adresa siete }
                 Node   : nodeAddr;  { adresa uzla }
                 Socket : word;      { cislo soketu}
               end;

  localAddrT = record
                 Net    : netAddr;   { "moja" adresa siete }
                 Node   : nodeAddr;  { "moja" adresa uzala }
               end;

  ECBType = record
              link      : address;    { Pointer, nepouziva sa  }
              ESR       : address;    { ESR, 0h ak sa nepouziva }
              inUse     : byte;       { priznak pouzitia }
              complete  : byte;       { ukoncovaci kod }
              socket    : word;       { cislo soketu }
              IPXwork   : array[1..4] of byte;  { pracovny priestor IPX }
              Dwork     : array[1..12] of byte; { pracovny priestor ovladaca }
              immedAddr : nodeAddr;   { adresa najblizsieho uzla }
              fragCount : word;       { pocet fragmentor }
              fragData  : address;    { adresa fragmentu 1 }
              fragSize  : word;       { velkost fragmentu 1 }
            end;

  IPXheader = record
                check  : word;                { checksum }
                length : word;                { dlzka hlavicky v  bajtoch }
                tc     : byte;                { riadenie prenosu }
                pType  : byte;                { typ paketu }
                dest   : netAddress;          { adresa ciela }
                src    : netAddress;          { addresa zdroja }
              end;

const
{  MYSOCKET  : word = $6666;}
  BROADCAST : nodeAddr = ($ff,$ff,$ff,$ff,$ff,$ff);  { adresa pre BROADCAST }

var
  localAddr    : localAddrT; { na uchovanie "mojej" adresy }
  IPXinstalled : boolean;
  IPXlocation  : pointer;

{ IPXopenSocket - otvori soket cislo SocketNumber,
  longevity = $00 otvoreny pokial ho nezavrieme alebo neukoncime program
            = $ff otvoreny pokial ho nezavrieme, pouzitie pre TSR

  VYSTUP      $00 = ok
              $fe = dosiahnuty pocet max. otvorenych socketov
              $ff = socket je uz otvoreny }
function  IPXopenSocket(longevity : byte; var SocketNumber : word):byte;

{ IPXcloseSocket - zavrie soket SocketNumber }
procedure IPXcloseSocket(SocketNumber : word);

{ GetLocalAddress - do premennej localAddr da "moju" adresu }
procedure GetLocalAddress;

{ IPXsendPacket - posle paket, E je inicializovany ECB }
procedure IPXsendPacket(var E : ECBtype);

{ IPXlistenForPacket - prijme paket, E je inicializovany ECB }
{ po zavolani funckie je riadenie vratene spat aplikacii,
{ VYSTUP: $00 - ok }

function  IPXlistenForPacket(var E : ECBtype):byte;

{ ImIdle - oznamuje IPX ze prave nic nerobime }
procedure ImIdle;

{ InitSendPacket - nadstavi do ecb a ipx vsetky potrebne hodnoty }
{                  pre odoslanie paketu }
procedure InitSendPacket(var ecb : ecbType; var ipx : ipxHeader; size,sock : word);

{ InitReceivePacket - nadstavi do ecb a ipx vsetky potrebne hodnoty }
{                     na prijanie paketu }
procedure InitReceivePacket(var ecb : ecbType; var ipx : ipxHeader; size,sock : word);

{ InitIPX - inicializacia IPX, zistenie adresy na volanie IPX drivera }
procedure InitIPX;

{ IPXGetLocalTarget - pre zadanu adresu vrati adresu smerovaca, ktoru }
{                     treba zadat do ecb.immedAddr }
function IPXGetLocalTarget(dest_network:netAddr;dest_node:nodeAddr;
                            dest_socket:word; var bridge_addr:nodeAddr):byte;

implementation

{ IPXcall - zavola IPX driver s prislusnymi hodnotami v registroch }
procedure IPXcall(var R:Registers);
var   Ax1, Bx1,Cx1, Dx1, Di1, Si1, Es1 : word;
begin
 Ax1:=R.Ax;  { kedze priamo mov Ax,R.AX nemoze byt, }
 Bx1:=R.Bx;  { teba pouzit pomocne premenne }
 Cx1:=R.Cx;
 Dx1:=R.Dx;
 Di1:=R.Di;
 Si1:=R.Si;
 Es1:=R.Es;
 asm
  mov   Ax, Ax1
  mov   Bx, Bx1
  mov   Cx, Cx1
  mov   Dx, Dx1
  mov   Di, Di1
  mov   Si, Si1
  mov   Es, Es1
  push  Bp
  call  dword ptr IPXLocation { zavolanie IPX drivera }
  pop   Bp
  mov   Ax1, Ax
  mov   Dx1, Dx
 end;
 R.Ax:=Ax1;
 R.Dx:=Dx1;
end;


function IPXGetLocalTarget(dest_network:netAddr;dest_node:nodeAddr;
                            dest_socket:word; var bridge_addr:nodeAddr):byte;
var
  Regs      : Registers;
  Request   : record
               network_number    : netAddr;
               physical_node     : nodeAddr;
               socket            : word;
              end;
  Reply     : record
               local_target      : nodeAddr;
              end;
begin
 with Request do begin
  network_number := dest_network;
  physical_node := dest_node;
  socket := dest_socket;
 end;
 with Regs do begin
  Es := Seg(Request);
  Si := Ofs(Request);
  Di := Ofs(Reply);
  Bx := $0002;
  IPXCall(Regs);
  Ah := 0;
  IPXGetLocalTarget:=Al;
  bridge_addr := Reply.local_target;
 end
end;


function IPXopenSocket(longevity : byte; var socketNumber : word):byte;
var
  regs : registers;

begin
 regs.bx:=$0000;
 regs.al:=longevity;
 regs.dx:=swap(socketNumber);
 IPXCall(regs);
 if socketNumber=$0000 then
    socketNumber:=swap(regs.dx);
  IPXopenSocket:=regs.al;
end;

procedure IPXcloseSocket(socketNumber : word);
var
 regs : registers;

begin
 regs.bx:=$0001;
 regs.dx:=swap(socketNumber);
 IPXCall(regs);
end;

procedure GetLocalAddress;
var
 regs : registers;

begin
 regs.bx:=$0009;
 regs.es:=seg(localAddr);
 regs.si:=ofs(localAddr);
 IPXCall(regs);
end;

procedure IPXsendPacket(var E : ECBtype);
var
 regs : registers;

begin
 regs.bx:=$0003;
 regs.es:=seg(E);
 regs.SI:=ofs(E);
 IPXCall(regs);
end;

function IPXlistenForPacket(var E : ECBtype):byte;
var
 regs : registers;

begin
 regs.bx:=$0004;
 regs.es:=seg(E);
 regs.SI:=ofs(E);
 IPXCall(regs);
 IPXlistenForPacket:=regs.al;
end;

procedure ImIdle;
var
 regs : registers;

begin
 regs.bx:=$000A;
 IPXCall(regs);
end;

procedure InitSendPacket(var ecb : ecbType; var ipx : ipxHeader; size,sock : word);
begin
 fillChar(ecb,sizeOf(ecb),#0);
 fillChar(ipx,sizeOf(ipx),#0);
 with ecb do
   begin
    socket:=swap(sock);               { cislo socketu }
    fragCount:=1;                     { pocet fragmentov... }
    fragData[0]:=ofs(IPX);            { ...ich adresa... }
    fragData[1]:=seg(IPX);
    fragSize:=sizeof(IPX)+size;       { ...a velkost }
    immedAddr:=BROADCAST;             { zatial broadcast * }
   end;
 with ipx do
   begin
    check:=$ffff;                     { nie je checksum }
    ptype:=4;                         { vymenny packet }
    dest.net:=localAddr.net;          { lokalna siet * }
    dest.node:=BROADCAST;             { vsetkym }
    dest.socket:=swap(sock);          { moj socket * }
    src.net:=localAddr.net;           { je to z tejto siete...}
    src.node:=localAddr.node;         { ...nasej adresy...}
    src.socket:=swap(sock);           { ...a socketu }
   end;

    { * - hodnoty budu zmenene podla znamych sieti,
          v procedure Sendline }
end;

procedure InitReceivePacket(var ecb : ecbType; var ipx : ipxHeader; size,sock : word);
begin
 fillChar(ecb,sizeOf(ecb),#0);
 fillChar(ipx,sizeOf(ipx),#0);
 with ecb do
   begin
    inUse:=$1d;                               { ???? }
    socket:=swap(sock);                       { cislo soketu }
    fragCount:=1;                             { pocet fragmentov... }
    fragData[0]:=ofs(IPX);                    { ...ich adresa... }
    fragData[1]:=seg(IPX);
    fragSize:=sizeof(IPX)+size;               { ...a velkost }
   end;
 IPXlistenForPacket(ecb)                  { Cakaj na prijatie paketu }
end;

{ IPXnotloaded - tato procedura sa vykona ak nie je znamy ziaden ipx
                 driver, ale bola zavolana jeho funkcia.
                 Je to potrebne pre to, ze keby sme zavolali proc.
                 IPXCall(registre), ktora skace priamo na adresu ipx
                 drivera (a ten nie je) mohol by nastal "zmrz" }
procedure IPXnotloaded;
begin
 writeln('ipx function called but driver not found');
 halt;
end;

procedure InitIPX;
var
 i    : integer;
 regs : registers;

begin
 writeln('Initializing ipx...');
 with regs do
 begin
  AX:=$7A00;
  intr($2f,regs);  { Existuje IPX driver ? }
  if AL=$FF then   { ano }
   begin
    IPXinstalled:=True;
    IPXlocation:=Ptr(ES,DI); { adresa kam skocime ak ho budeme volat }
   end
   else begin { ak nie }
    IPXInstalled := False;
    IPXLocation := @IPXNotLoaded;
    writeln('ipx driver not loaded...aborting');
    halt;
  end;
 end; { with...}
 getLocalAddress; { zisti si nasu adresu }
end;


begin
IPXInstalled := False;
IPXLocation := @IPXNotLoaded;
end.
